jQuery(document).ready(function($) {
	// tinysliderlist
	var tinysliders = null;
	// show all tinysliders
	show_list();
	
	// events
	$(':checkbox').click(function(e) {	
		var id = e.target.id;
		var elname = 'plugintinyslider-cb';
		
		if (id.substring(0, elname.length) == elname) {
			$(':checkbox').attr('checked', $(this).is(':checked'));		
		}
	});
	$('#plugintinyslider-add').click(function(e) {
		show_dialog_add();
	});
	$('#plugintinyslider-delete').click(function(e) {
		var idlist = [];
		var elname = 'plugintinyslider-checkbox-';
		var count = 0;
        $('input:checkbox:checked').each(function(i) {
        	if ($(this).attr('id').indexOf(elname, 0) > -1) {
        		idlist[count] = $(this).val();
        		count++;
        	}
        });
        if (idlist.length > 0) {
        	var result = remove(idlist.join(','));
        	if (result[0] == true) {
        		show_list();
        		$(this).dialog('close');
        		show_dialog_notification(result[1].responseText);
        	} else {
        		$(this).dialog('close');
        		show_dialog_error(result[1].responseText);
        	}
        } else {
        	$(this).dialog('close');
        	show_dialog_error(message_select_least);
        }
	});
	$('#plugintinyslider-update').click(function(e) {
        if ($('input:checkbox:checked').size() != 1) {
        	show_dialog_error(message_select_single);
        } else {
        	var id = $('input:checkbox:checked').val();
        	var thetiny = null;
        	$.each(tinysliders, function(i) {
        		if (tinysliders[i].id == id) {
        			thetiny = tinysliders[i];
        		}
        	});
        	$('#plugintinyslider-update-title').val(thetiny.title);
        	$('#plugintinyslider-update-temporisation').val(thetiny.temporisation);
        	$('#plugintinyslider-update-gallery').val(thetiny.gallery);
        	$('#plugintinyslider-update-pagination').val(thetiny.pagination);
        	$('#plugintinyslider-update-vertical').val(thetiny.vertical);
        	show_dialog_update();
        }
	});
	// dialogs
	$('#plugintinyslider-dialog-add').dialog({
		position: ['center', 'middle'],
		modal: true,
		draggable: false,
		resizable: false, 
		closeText: 'X',
		width: 400,
		height: 460,
		autoOpen: false,
		buttons: {
			'ajouter': function() {
				$('#plugintinyslider-add-error').hide();
				if ($('#plugintinyslider-add-gallery option:selected').val() == ''
				|| $('#plugintinyslider-add-gallery option:selected').size() < 1) {
					$('#plugintinyslider-add-error-message').text(message_gallery_required);
					$('#plugintinyslider-add-error').show();
				} else {
					//FIXME validate
					var tinyslider = ({
						title: $('#plugintinyslider-add-title').val(),
						temporisation: $('#plugintinyslider-add-temporisation').val(),
						gallery: $('#plugintinyslider-add-gallery option:selected').val(), 
						pagination: $('#plugintinyslider-add-pagination option:selected').val(),
						vertical: $('#plugintinyslider-add-vertical option:selected').val()
					});
					var result = add(tinyslider);
					if (result[0] == true) {
						show_list();
						$(this).dialog('close');
						show_dialog_notification(result[1].substring(0, result[1].length -1));
					} else {
						$('#plugintinyslider-add-error-message').text(result[1].responseText);
						$('#plugintinyslider-add-error').show();
					}
				}
			},
			'annuler': function() {
				$(this).dialog('close');
			}
		}
	});
	$('#plugintinyslider-dialog-update').dialog({
		position: ['center', 'middle'],
		modal: true,
		draggable: false,
		resizable: false, 
		closeText: 'X',
		width: 400,
		height: 460,
		autoOpen: false,
		buttons: {
			'enregistrer': function() {
				$('#plugintinyslider-update-error').hide();
				if ($('#plugintinyslider-update-gallery option:selected').val() == ''
				|| $('#plugintinyslider-update-gallery option:selected').size() < 1) {
					$('#plugintinyslider-update-error-message').text(message_gallery_required);
					$('#plugintinyslider-update-error').show();
				} else {
					//FIXME validate
					var tinyslider = ({
						id: $('input:checkbox:checked').val(),
						title: $('#plugintinyslider-update-title').val(),
						temporisation: $('#plugintinyslider-update-temporisation').val(),
						gallery: $('#plugintinyslider-update-gallery option:selected').val(), 
						pagination: $('#plugintinyslider-update-pagination option:selected').val(),
						vertical: $('#plugintinyslider-update-vertical option:selected').val()
					});
					var result = update(tinyslider);
					if (result[0] == true) {
						show_list();
						$(this).dialog('close');
						show_dialog_notification(result[1].substring(0, result[1].length -1));
					} else {
						$('#plugintinyslider-update-error-message').text(result[1].responseText);
						$('#plugintinyslider-update-error').show();
					}
				}
			},
			'annuler': function() {
				$(this).dialog('close');
			}
		}
	});
	$('#plugintinyslider-dialog-error').dialog({
		closeOnEscape: false,
		position: ['center', 'middle'],
		modal: true,
		draggable: false,
		resizable: false, 
		closeText: 'X',
		autoOpen: false,
		buttons: {
			'ok': function() {
				$(this).dialog('close');
			}
		}
	});
	$('#plugintinyslider-dialog-notification').dialog({
		closeOnEscape: false,
		position: ['center', 'middle'],
		modal: true,
		draggable: false,
		resizable: false, 
		closeText: 'X',
		autoOpen: false,
		buttons: {
			'ok': function() {
				$(this).dialog('close');
			}
		}
	});
	// dialogs action
	function show_dialog_add() {
		$('#plugintinyslider-add-error').hide();
		$('#plugintinyslider-dialog-add').parent().children().eq(2).children().eq(1).text(label_cancel);
		$('#plugintinyslider-dialog-add').parent().children().eq(2).children().eq(0).text(label_add);
		$('#plugintinyslider-dialog-add').dialog('open');
	}
	function show_dialog_update() {
		$('#plugintinyslider-update-error').hide();
		$('#plugintinyslider-dialog-update').parent().children().eq(2).children().eq(1).text(label_cancel);
		$('#plugintinyslider-dialog-update').parent().children().eq(2).children().eq(0).text(label_save);
		$('#plugintinyslider-dialog-update').dialog('open');
	}
	function show_dialog_error(message) {
		$('#plugintinyslider-error-message').text(message);
		$('#plugintinyslider-dialog-error').parent().children().eq(2).children().eq(0).text(label_ok);
		$('#plugintinyslider-dialog-error').dialog('open');
	}
	function show_dialog_notification(message) {
		$('#plugintinyslider-notification-message').text(message);
		$('#plugintinyslider-dialog-notification').parent().children().eq(2).children().eq(0).text(label_ok);
		$('#plugintinyslider-dialog-notification').dialog('open');
	}
	// tinysliderlist
	function show_list() {
		list();
		$('#plugintinyslider-list > *').remove();
		if (tinysliders != null) {
			$.each(tinysliders, function(i) {
				$('#plugintinyslider-list').append('<tr id="tinyslider-' + i + '">');
				$('#tinyslider-' + i).append('<th id="tinyslider-cb-' + i + '" class="check-column" scope="row"></th>');
				$('#tinyslider-cb-' + i).append('<input id="plugintinyslider-checkbox-' + i + '" class="administrator" type="checkbox" value="' + tinysliders[i].id + '" name="tinyslider-checkbox[]">');
				$('#tinyslider-' + i).append('<td class="title column-title"><span id="plugintinyslider-title-' + tinysliders[i].id + '">' + tinysliders[i].title + '</span></td>');
				$('#tinyslider-' + i).append('<td class="temporisation column-temporisation"><span id="plugintinyslider-temporisation-' + tinysliders[i].id + '">' + tinysliders[i].temporisation + '</span></td>');
				$('#tinyslider-' + i).append('<td class="gallery column-gallery"><span id="plugintinyslider-gallery-' + tinysliders[i].id + '">' + tinysliders[i].gallery + '</span></td>');
				$('#tinyslider-' + i).append('<td class="pagination column-pagination"><span id="plugintinyslider-pagination-' + tinysliders[i].id + '">' + ((tinysliders[i].pagination == 'index') ? pagination_index : pagination_name) + '</span></td>');
				$('#tinyslider-' + i).append('<td class="vertical column-vertical"><span id="plugintinyslider-vertical-' + tinysliders[i].id + '">' + ((tinysliders[i].vertical == 'true') ? vertical_true : vertical_false) + '</span></td>');
				$('#tinyslider-' + i).append('<td class="shortcode column-shortcode"><span>[plugintinyslider id="' + tinysliders[i].id + '"]</span></td>');
			});
		} else {
			$('#plugintinyslider-list').append('<tr><th colspan="7">' + message_no_tinyslider + '</th></tr>');
		}
	}
	// actions
	function add(tinyslider) {
		var params = ({
			action: 'tinyslider_add',
			tinyslider_title: tinyslider.title,
			tinyslider_temporisation: tinyslider.temporisation,
			tinyslider_gallery: tinyslider.gallery,
			tinyslider_pagination: tinyslider.pagination,
			tinyslider_vertical: tinyslider.vertical,
			cookie: encodeURIComponent(document.cookie)
		});
		var data = exec_ajax(params);
		return data;
	}
	function update(tinyslider) {
		var params = ({
			action: 'tinyslider_update',
			tinyslider_id: tinyslider.id,
			tinyslider_title: tinyslider.title,
			tinyslider_temporisation: tinyslider.temporisation,
			tinyslider_gallery: tinyslider.gallery,
			tinyslider_pagination: tinyslider.pagination,
			tinyslider_vertical: tinyslider.vertical,
			cookie: encodeURIComponent(document.cookie)
		});
		var data = exec_ajax(params);
		return data;
	}
	function remove(tinyslider_ids) {
		var params = ({
			action: 'tinyslider_delete',
			tinyslider_ids: tinyslider_ids,
			cookie: encodeURIComponent(document.cookie)
		});
		var data = exec_ajax(params);
		return data;
	}
	function list() {
		var params = ({
			action: 'tinyslider_list',
			cookie: encodeURIComponent(document.cookie)
		});
		tinysliders = null;
		var result = exec_ajax(params);
		if (result[0] == true 
		&& result[1] != '0') {
			var data = result[1];
			tinysliders = $.evalJSON(data.substring(0, data.length - 1));
		}
	}
	// ajax request
	function exec_ajax(params) {
		var result = [];
		$.ajax({
			async: false,
			type: 'POST',
			url: ajaxurl, 
			data: params,
			success: function(data) {
				result[0] = true;
				result[1] = data;
			},
			error: function(data) {
				result[0] = false;
				result[1] = data;
			}
		});
		return result;
	}
});